package Prog1Tools;

import java.awt.*;
import net.sourceforge.c4j.*;

/** 
 * Spezifikation eines Grafikelements.
 * 
 * @author  hagen.buchwald@kit.edu
 * @version 1.11
 * @date 2011-04-24
 */
@ContractReference (contractClassName = "GraphicItemSpecContract")
public interface GraphicItemSpec
{
    /**
     * Kommando zum Zeichnen des Grafikelements.
     * 
     * @param graphics Grafikkontext, auf den das Grafikelement gezeichnet werden soll
     */
    public void paint (Graphics graphics);
	
    /**
     * Kommando zum Ausblenden des Grafikelements.
     */
    public void show ();
	
    /**
     * Kommando zum Einblenden des Grafikelements.
     */
    public void hide ();

	/**
	 * Abfrage, ob das Grafikelement eingeblendet und damit sichtbar ist.
	 * 
	 * @return true, wenn das Grafikelement eingeblendet ist; false sonst
	 */
	@Pure
	public boolean isVisible ();

	/**
	 * Kommando, das Grafikelement zu verschieben.
	 * Die Verschiebung wird beim naechsten repaint des GraphicScreens sichtbar.
	 * 
	 * @param xDistance Anzahl der Pixel, um die das Grafikelement vertikal verschoben werden soll
	 * @param yDistance Anzahl der Pixel, um die das Grafikelement horizontal verschoben werden soll
	 */
	public void move (int xDistance, int yDistance);

}
