package Prog1Tools;

import java.awt.*;
import net.sourceforge.c4j.*;

/** 
 * Vertragsklasse der Spezifikation eines Grafikelements.
 * 
 * @author  hagen.buchwald@kit.edu
 * @version 1.11
 * @date 2011-04-24
 */
public class GraphicItemSpecContract extends ContractBase<GraphicItemSpec>
{
    public GraphicItemSpecContract (GraphicItemSpec target)
    {
        super (target);
    }
    
    public void pre_paint (Graphics graphics)
    {
        assert graphics != null : "graphics_not_null";
    }
    
    public void post_paint (Graphics graphics)
    {
        // no post-condition identified yet
    }

    public void pre_show ()
    {
    	// no pre-condition identified yet
    }

    public void post_show ()
    {
    	assert m_target.isVisible() : "isVisible";
    }

    public void pre_hide ()
    {
    	// no pre-condition identified yet
    }

    public void post_hide ()
    {
    	assert !m_target.isVisible() : "not_isVisible";
    }

    public void pre_isVisible ()
    {
    	// no pre-condition identified yet
    }

    public void post_isVisible ()
    {
    	// no post-condition identified yet
    }

    public void pre_move (int xDistance, int yDistance)
    {
    	// no pre-condition identified yet
    }

    public void post_move (int xDistance, int yDistance)
    {
    	// no post-condition identified yet
    }

}
