package Prog1Tools;

import java.awt.*;

/** 
 * Implementierung des Grafikelements Linie.
 * 
 * @author  hagen.buchwald@kit.edu
 * @version 1.1
 * @date 2011-03-23
 */
public class GraphicLine extends GraphicItem
{
    private int x1;
    private int y1;
    private int x2;
    private int y2;
    private Color color;
    
    /**
     * Konstruktor des Grafikelements Linie.
     * 
     * @param x1 x-Koordinate des Startpunktes der Linie
     * @param y1 y-Koordinate des Startpunktes der Linie
     * @param x2 x-Koordinate des Endpunktes der Linie
     * @param y2 y-Koordinate des Endpunktes der Linie
     * @param color Farbe, in der die Linie gezeichnet werden soll
     */
    public GraphicLine (int x1, int y1, int x2, int y2, Color color)
    {
        this.color = color;
        this.x1 = x1;
        this.y1 = y1;
        this.x2 = x2;
        this.y2 = y2;
    }
    
    public void paint (Graphics graphics)
    {
        Color oldColor = graphics.getColor();
        graphics.setColor(color);
        graphics.drawLine(x1,y1, x2, y2);
        graphics.setColor(oldColor);
    }

    public void move (int xDistance, int yDistance)
    {
    	x1 = x1 + xDistance;
    	x2 = x2 + xDistance;
    	y1 = y1 + yDistance;
    	y2 = y2 + yDistance;
    }
    
}
    
