package Prog1Tools;

import java.awt.*;

/** 
 * Implementierung des Grafikelements Oval.
 * 
 * @author  hagen.buchwald@kit.edu
 * @version 1.0
 * @date 2010-08-30
 */
public class GraphicOval implements GraphicItemSpec
{
    private int x;
    private int y;
    private int width;
    private int height;
    private Color color;
    private boolean isFilled;
    
    /**
     * Konstruktor des Grafikelements Oval.
     * 
     * @param x x-Koordinate der oberen linken Ecke des gedachten Rechtecks, das das zu zeichnende Oval umgibt
     * @param y y-Koordinate der oberen linken Ecke des gedachten Rechtecks, das das zu zeichnende Oval umgibt
     * @param width Breite des gedachten Rechtecks, das das zu zeichnende Oval umgibt
     * @param height Hoehe des gedachten Rechtecks, das das zu zeichnende Oval umgibt
     * @param color Farbe, in der das Oval gezeichnet werden soll
     * @param isFilled bei false wird nur der Linienzug des Ovals gezeichnet;
     * bei true wird die Flaeche des Ovals in der Zeichenfarbe eingefaerbt
     */
    public GraphicOval (int x, int y, int width, int height, Color color, boolean isFilled)
    {
        this.x = x;
        this.y = y;
        this.width = width;
        this.height = height;
        this.color = color;
        this.isFilled = isFilled;
    }
    
    public void paint (Graphics graphics)
    {
        Color oldColor = graphics.getColor();
        graphics.setColor(color);
        if (!isFilled)
        {
            graphics.drawOval(x, y, width, height);
        }
        else
        {
            graphics.fillOval(x, y, width, height);
        }
        graphics.setColor(oldColor);
    }
}
    
