package Prog1Tools;

import java.awt.*;

/** 
 * Implementierung des Grafikelements Polygon.
 * 
 * @author  hagen.buchwald@kit.edu
 * @version 1.0
 * @date 2010-08-30
 */
public class GraphicPolygon implements GraphicItemSpec
{
    private int[] xPoints;
    private int[] yPoints;
    private int nPoints;
    private Color color;
    private boolean isFilled;
    
    /**
     * Konstruktor des Grafikelements Polygon.
     * 
     * @param xPoints x-Koordinaten aller Punkte des Polygons
     * @param yPoints y-Koordinaten aller Punkte des Polygons
     * @param nPoints Anzahl der Punkte, bis zu der das Polygon gezeichnet werden soll
     * @param color Farbe, in der das Polygon gezeichnet werden soll
     * @param isFilled bei false wird nur der Linienzug des Polygons gezeichnet;
     * bei true wird die Flaeche des Polygons in der Zeichenfarbe eingefaerbt
     */
    public GraphicPolygon (int[] xPoints, int[] yPoints, int nPoints, Color color, boolean isFilled)
    {
        this.nPoints = nPoints;
        this.color = color;
        this.xPoints = new int[nPoints];
        this.yPoints = new int[nPoints];
        for (int i = 0; i < nPoints; i++)
        {
            this.xPoints[i] = xPoints[i];
            this.yPoints[i] = yPoints[i];
        }
        this.isFilled = isFilled;
    }
    
     public void paint (Graphics graphics)
    {
        Color oldColor = graphics.getColor();
        graphics.setColor(color);
        if (!isFilled)
        {
            graphics.drawPolygon(xPoints, yPoints, nPoints);
        }
        else
        {
            graphics.fillPolygon(xPoints, yPoints, nPoints);
        }
        graphics.setColor(oldColor);
    }
}
    
