package Prog1Tools;

import java.awt.*;

/** 
 * Implementierung des Grafikelements Polylinie.
 * 
 * @author  hagen.buchwald@kit.edu
 * @version 1.1
 * @date 2011-03-23
 */
public class GraphicPolyline extends GraphicItem
{
    private int[] xPoints;
    private int[] yPoints;
    private int nPoints;
    private Color color;
    
    /**
     * Konstruktor des Grafikelements Polylinie.
     * 
     * @param xPoints x-Koordinaten aller Punkte der Polylinie
     * @param yPoints y-Koordinaten aller Punkte der Polylinie
     * @param nPoints Anzahl der Punkte, bis zu der die Polylinie gezeichnet werden soll
     * @param color Farbe, in der die Polylinie gezeichnet werden soll
     */
    public GraphicPolyline (int[] xPoints, int[] yPoints, int nPoints, Color color)
    {
        this.nPoints = nPoints;
        this.color = color;
        this.xPoints = new int[nPoints];
        this.yPoints = new int[nPoints];
        for (int i = 0; i < nPoints; i++)
        {
            this.xPoints[i] = xPoints[i];
            this.yPoints[i] = yPoints[i];
        }
    }
    
    public void paint (Graphics graphics)
    {
        Color oldColor = graphics.getColor();
        graphics.setColor(color);
        graphics.drawPolyline(xPoints, yPoints, nPoints);
        graphics.setColor(oldColor);
    }

    public void move (int xDistance, int yDistance)
    {
    	int index = 0;
    	for (index = 0; index < nPoints; index = index + 1)
    	{
    		xPoints[index] = xPoints[index] + xDistance;
    		yPoints[index] = yPoints[index] + yDistance;
    	}
    }
}
    
