package Prog1Tools;

import java.awt.*;

/** 
 * Implementierung des Grafikelements Polylinie.
 * 
 * @author  hagen.buchwald@kit.edu
 * @version 1.0
 * @date 2010-08-30
 */
public class GraphicPolyline implements GraphicItemSpec
{
    private int[] xPoints;
    private int[] yPoints;
    private int nPoints;
    private Color color;
    
    /**
     * Konstruktor des Grafikelements Polylinie.
     * 
     * @param xPoints x-Koordinaten aller Punkte der Polylinie
     * @param yPoints y-Koordinaten aller Punkte der Polylinie
     * @param nPoints Anzahl der Punkte, bis zu der die Polylinie gezeichnet werden soll
     * @param color Farbe, in der die Polylinie gezeichnet werden soll
     */
    public GraphicPolyline (int[] xPoints, int[] yPoints, int nPoints, Color color)
    {
        this.nPoints = nPoints;
        this.color = color;
        this.xPoints = new int[nPoints];
        this.yPoints = new int[nPoints];
        for (int i = 0; i < nPoints; i++)
        {
            this.xPoints[i] = xPoints[i];
            this.yPoints[i] = yPoints[i];
        }
    }
    
    public void paint (Graphics graphics)
    {
        Color oldColor = graphics.getColor();
        graphics.setColor(color);
        graphics.drawPolyline(xPoints, yPoints, nPoints);
        graphics.setColor(oldColor);
    }
}
    
