package Prog1Tools;

import java.awt.*;

/** 
 * Implementierung des Grafikelements Rechteck.
 * 
 * @author  hagen.buchwald@kit.edu
 * @version 1.0
 * @date 2010-08-30
 */
public class GraphicRectangle implements GraphicItemSpec
{
    private int x;
    private int y;
    private int width;
    private int height;
    private Color color;
    private boolean isFilled;
    
    /**
     * Konstruktor des Grafikelements Rechteck.
     * 
     * @param x x-Koordinate der oberen linken Ecke des Rechtecks
     * @param y y-Koordinate der oberen linken Ecke des Rechtecks
     * @param width Breite des Rechtecks
     * @param height Hoehe des Rechtecks
     * @param color Farbe, in der das Rechteck gezeichnet werden soll
     * @param isFilled bei false wird nur der Linienzug des Rechtecks gezeichnet;
     * bei true wird die Flaeche des Rechtecks in der Zeichenfarbe eingefaerbt
     */
    public GraphicRectangle (int x, int y, int width, int height, Color color, boolean isFilled)
    {
        this.x = x;
        this.y = y;
        this.width = width;
        this.height = height;
        this.color = color;
        this.isFilled = isFilled;
    }
    
    public void paint (Graphics graphics)
    {
        Color oldColor = graphics.getColor();
        graphics.setColor(color);
        if (!isFilled)
        {
            graphics.drawRect(x, y, width, height);
        }
        else
        {
            graphics.fillRect(x, y, width, height);
        }
        graphics.setColor(oldColor);
    }
}
    
