package Prog1Tools;

import java.awt.*;

/** 
 * Implementierung des Grafikelements Rechteck mit 3D-Effekt.
 * 
 * @author  hagen.buchwald@kit.edu
 * @version 1.1
 * @date 2011-03-23
 */
public class GraphicRectangle3D extends GraphicItem
{
    private int x;
    private int y;
    private int width;
    private int height;
    private Color color;
    private boolean isFilled;
    private boolean isRaised;
    
    /**
     * Konstruktor des Grafikelements Rechteck mit 3D-Effekt.
     * 
     * @param x x-Koordinate der oberen linken Ecke des Rechtecks
     * @param y y-Koordinate der oberen linken Ecke des Rechtecks
     * @param width Breite des Rechtecks
     * @param height Hoehe des Rechtecks
     * @param color Farbe, in der das Rechteck gezeichnet werden soll
     * @param isFilled bei false wird nur der Linienzug des Rechtecks gezeichnet;
     * bei true wird die Flaeche des Rechtecks in der Zeichenfarbe eingefaerbt
     * @param isRaised bei false wird das Rechteck eingestanzt gezeichnet;
     * bei true wird das Rechteck erhoben gezeichnet
     */
    public GraphicRectangle3D (int x, int y, int width, int height, Color color, boolean isFilled, boolean isRaised)
    {
        this.x = x;
        this.y = y;
        this.width = width;
        this.height = height;
        this.color = color;
        this.isFilled = isFilled;
        this.isRaised = isRaised;
    }
    
    public void paint (Graphics graphics)
    {
        Color oldColor = graphics.getColor();
        graphics.setColor(color);
        if (!isFilled)
        {
            graphics.draw3DRect(x, y, width, height, isRaised);
        }
        else
        {
            graphics.fill3DRect(x, y, width, height, isRaised);
        }
        graphics.setColor(oldColor);
    }

    public void move (int xDistance, int yDistance)
    {
    	x = x + xDistance;
    	y = y + yDistance;
    }
}
    
