package Prog1Tools;

import net.sourceforge.c4j.*;
import java.awt.Color;

/** 
 * Vertragsklasse der Spezifikation eines grafikfaehigen Farbbildschirms.
 * 
 * @author  hagen.buchwald@kit.edu
 * @version 1.11
 * @date 2011-04-23
 */
public class GraphicScreenSpecContract extends ContractBase<GraphicScreenSpec>
{
    public GraphicScreenSpecContract (GraphicScreenSpec target)
    {
        super (target);
    }
    
    public void pre_getColor ()
    {
        // no pre-condition identified yet
    }
    
    public void post_getColor ()
    {
        assert getReturnValue() != null : "returnValue_not_null"; 
    }
    
    public void pre_setColor (Color color)
    {
        assert color != null : "color_not_null";
    }
    
    public void post_setColor (Color color)
    {
        assert color.equals(m_target.getColor()) : "color_set";
    }
    
    public void pre_setOrigin (int x, int y)
    {
        // no pre-condition identified yet
    }
    
    public void post_setOrigin (int x, int y)
    {
        assert x == m_target.getOrigin().getX() : "x_set";
        assert y == m_target.getOrigin().getY() : "y_set";
    }
    
    public void pre_getOrigin ()
    {
        // no pre-condition identified yet
    }
    
    public void post_getOrigin ()
    {
        assert getReturnValue() != null : "returnValue_not_null"; 
    }
    
    public void pre_drawOrigin ()
    {
        // no pre-condition identified yet
    }
    
    public void post_drawOrigin ()
    {
        // no post-condition identified yet
    }
    
    public void pre_drawLine (int x1, int y1, int x2, int y2)
    {
        // no pre-condition identified yet
        setPreconditionValue("old_numberOfItems", m_target.getNumberOfItems());
    }
    
    public void post_drawLine (int x1, int y1, int x2, int y2)
    {
        int old_numberOfItems = (Integer) getPreconditionValue("old_numberOfItems");
        assert m_target.getNumberOfItems() >= old_numberOfItems + 1 : "numberOfItems_increased";
    }
    
    public void pre_drawPolyline (int[] xPoints, int[] yPoints, int nPoints)
    {
        // no pre-condition identified yet
        setPreconditionValue("old_numberOfItems", m_target.getNumberOfItems());
    }
    
    public void post_drawPolyline (int[] xPoints, int[] yPoints, int nPoints)
    {
        int old_numberOfItems = (Integer) getPreconditionValue("old_numberOfItems");
        assert m_target.getNumberOfItems() >= old_numberOfItems + 1 : "numberOfItems_increased";
    }
    
    public void pre_drawPolygon (int[] xPoints, int[] yPoints, int nPoints, boolean isFilled)
    {
        // no pre-condition identified yet
        setPreconditionValue("old_numberOfItems", m_target.getNumberOfItems());
    }
    
    public void post_drawPolygon (int[] xPoints, int[] yPoints, int nPoints, boolean isFilled)
    {
        int old_numberOfItems = (Integer) getPreconditionValue("old_numberOfItems");
        assert m_target.getNumberOfItems() >= old_numberOfItems + 1 : "numberOfItems_increased";
    }
    
    public void pre_drawText (int x, int y, String text)
    {
        // no pre-condition identified yet
        setPreconditionValue("old_numberOfItems", m_target.getNumberOfItems());
    }
    
    public void post_drawText (int x, int y, String text)
    {
        int old_numberOfItems = (Integer) getPreconditionValue("old_numberOfItems");
        assert m_target.getNumberOfItems() >= old_numberOfItems + 1 : "numberOfItems_increased";
    }
    
    public void pre_drawCircle (int x, int y, int radius, boolean isFilled)
    {
        // no pre-condition identified yet
        setPreconditionValue("old_numberOfItems", m_target.getNumberOfItems());
    }
    
    public void post_drawCircle (int x, int y, int radius, boolean isFilled)
    {
        int old_numberOfItems = (Integer) getPreconditionValue("old_numberOfItems");
        assert m_target.getNumberOfItems() >= old_numberOfItems + 1 : "numberOfItems_increased";
    }
    
    public void pre_drawOval (int x, int y, int width, int height, boolean isFilled)
    {
        // no pre-condition identified yet
        setPreconditionValue("old_numberOfItems", m_target.getNumberOfItems());
    }
    
    public void post_drawOval (int x, int y, int width, int height, boolean isFilled)
    {
        int old_numberOfItems = (Integer) getPreconditionValue("old_numberOfItems");
        assert m_target.getNumberOfItems() >= old_numberOfItems + 1 : "numberOfItems_increased";
    }
    
    public void pre_drawRectangle (int x, int y, int width, int height, boolean isFilled)
    {
        // no pre-condition identified yet
        setPreconditionValue("old_numberOfItems", m_target.getNumberOfItems());
    }
    
    public void post_drawRectangle (int x, int y, int width, int height, boolean isFilled)
    {
        int old_numberOfItems = (Integer) getPreconditionValue("old_numberOfItems");
        assert m_target.getNumberOfItems() >= old_numberOfItems + 1 : "numberOfItems_increased";
    }
    
    public void pre_drawRectangle3D (int x, int y, int width, int height, boolean isFilled, boolean isRaised)
    {
        // no pre-condition identified yet
        setPreconditionValue("old_numberOfItems", m_target.getNumberOfItems());
    }
    
    public void post_drawRectangle3D (int x, int y, int width, int height, boolean isFilled, boolean isRaised)
    {
        int old_numberOfItems = (Integer) getPreconditionValue("old_numberOfItems");
        assert m_target.getNumberOfItems() >= old_numberOfItems + 1 : "numberOfItems_increased";
    }
    
    public void pre_drawRectangleRounded (int x, int y, int width, int height, int arcWidth, int arcHeight, boolean isFilled)
    {
        // no pre-condition identified yet
        setPreconditionValue("old_numberOfItems", m_target.getNumberOfItems());
    }
    
    public void post_drawRectangleRounded (int x, int y, int width, int height, int arcWidth, int arcHeight, boolean isFilled)
    {
        int old_numberOfItems = (Integer) getPreconditionValue("old_numberOfItems");
        assert m_target.getNumberOfItems() >= old_numberOfItems + 1 : "numberOfItems_increased";
    }
    
    public void pre_drawArc (int x, int y, int width, int height, int startAngle, int arcAngle, boolean isFilled)
    {
        // no pre-condition identified yet
        setPreconditionValue("old_numberOfItems", m_target.getNumberOfItems());
    }
    
    public void post_drawArc (int x, int y, int width, int height, int startAngle, int arcAngle, boolean isFilled)
    {
        int old_numberOfItems = (Integer) getPreconditionValue("old_numberOfItems");
        assert m_target.getNumberOfItems() >= old_numberOfItems + 1 : "numberOfItems_increased";
    }
    
    public void pre_getNumberOfItems ()
    {
        // no pre-condition identified yet
    }
    
    public void post_getNumberOfItems ()
    {
        int result = (Integer) getReturnValue();
        assert result >= 0 : "result_>=_0";
    }
    
    
    public void pre_getMaxX ()
    {
        // no pre-condition identified yet
    }
    
    public void post_getMaxX ()
    {
        int result = (Integer) getReturnValue();
        assert result > 0 : "result_>_0";
    }
    
    public void pre_getMaxY ()
    {
        // no pre-condition identified yet
    }
    
    public void post_getMaxY ()
    {
        int result = (Integer) getReturnValue();
        assert result > 0 : "result_>_0";
    }
    
    public void pre_getMaxNumberOfItems ()
    {
        // no pre-condition identified yet
    }
    
    public void post_getMaxNumberOfItems ()
    {
        int result = (Integer) getReturnValue();
        assert result > 0 : "result_>_0";
    }

    public void pre_getItem (int index)
    {
    	assert index >= 0 : "index_>=_0";
    	assert index < m_target.getNumberOfItems() : "index_<_numberOfItems";
    }

	public void post_getItem (int index)
	{
		GraphicItemSpec result = (GraphicItemSpec) getReturnValue();
		assert result != null : "result_not_null";
	}
	
}
