package Prog1Tools;

import net.sourceforge.c4j.*;
import java.awt.Color;

/** 
 * Vertragsklasse der Spezifikation eines grafikfaehigen Farbbildschirms.
 * 
 * @author  hagen.buchwald@kit.edu
 * @version 1.0
 * @date 2010-08-30
 */
public class GraphicScreenSpecContract extends ContractBase<GraphicScreenSpec>
{
    public GraphicScreenSpecContract (GraphicScreenSpec target)
    {
        super (target);
    }
    
    public void pre_clearScreen ()
    {
        
    }
    
    public void post_clearScreen ()
    {
        getThis();
        assert numberOfItems == 0 : "numberOfItems_==_0";
    }
    
    public void pre_repaint ()
    {
        
    }
    
    public void post_repaint ()
    {
        
    }
    
    public void pre_getColor ()
    {
        
    }
    
    public void post_getColor ()
    {
        assert getReturnValue() != null : "returnValue_not_null"; 
    }
    
    public void pre_setColor (Color color)
    {
        assert color != null : "color_not_null";
    }
    
    public void post_setColor (Color color)
    {
        assert color.equals(m_target.getColor()) : "color_set";
    }
    
    public void pre_setOrigin (int x, int y)
    {
        
    }
    
    public void post_setOrigin (int x, int y)
    {
        assert x == m_target.getOrigin().getX() : "x_set";
        assert y == m_target.getOrigin().getY() : "y_set";
    }
    
    public void pre_getOrigin ()
    {
        
    }
    
    public void post_getOrigin ()
    {
        assert getReturnValue() != null : "returnValue_not_null"; 
    }
    
    public void pre_drawOrigin ()
    {
        
    }
    
    public void post_drawOrigin ()
    {
        
    }
    
    public void pre_drawLine (int x1, int y1, int x2, int y2)
    {
        setOld();
    }
    
    public void post_drawLine (int x1, int y1, int x2, int y2)
    {
        getThis();
        getOld();
        assert numberOfItems == old_numberOfItems + 1 : "numberOfItems_increased";
    }
    
    public void pre_drawPolyline (int[] xPoints, int[] yPoints, int nPoints)
    {
        setOld();
    }
    
    public void post_drawPolyline (int[] xPoints, int[] yPoints, int nPoints)
    {
        getThis();
        getOld();
        assert numberOfItems == old_numberOfItems + 1 : "numberOfItems_increased";
    }
    
    public void pre_drawPolygon (int[] xPoints, int[] yPoints, int nPoints, boolean isFilled)
    {
        setOld();
    }
    
    public void post_drawPolygon (int[] xPoints, int[] yPoints, int nPoints, boolean isFilled)
    {
        getThis();
        getOld();
        assert numberOfItems == old_numberOfItems + 1 : "numberOfItems_increased";
    }
    
    public void pre_drawText (int x, int y, String text)
    {
        setOld();
    }
    
    public void post_drawText (int x, int y, String text)
    {
        getThis();
        getOld();
        assert numberOfItems == old_numberOfItems + 1 : "numberOfItems_increased";
    }
    
    public void pre_drawCircle (int x, int y, int radius, boolean isFilled)
    {
        setOld();
    }
    
    public void post_drawCircle (int x, int y, int radius, boolean isFilled)
    {
        getThis();
        getOld();
        assert numberOfItems == old_numberOfItems + 1 : "numberOfItems_increased";
    }
    
    public void pre_drawOval (int x, int y, int width, int height, boolean isFilled)
    {
        setOld();
    }
    
    public void post_drawOval (int x, int y, int width, int height, boolean isFilled)
    {
        getThis();
        getOld();
        assert numberOfItems == old_numberOfItems + 1 : "numberOfItems_increased";
    }
    
    public void pre_drawRectangle (int x, int y, int width, int height, boolean isFilled)
    {
        setOld();
    }
    
    public void post_drawRectangle (int x, int y, int width, int height, boolean isFilled)
    {
        getThis();
        getOld();
        assert numberOfItems == old_numberOfItems + 1 : "numberOfItems_increased";
    }
    
    public void pre_drawRectangle3D (int x, int y, int width, int height, boolean isFilled, boolean isRaised)
    {
        setOld();
    }
    
    public void post_drawRectangle3D (int x, int y, int width, int height, boolean isFilled, boolean isRaised)
    {
        getThis();
        getOld();
        assert numberOfItems == old_numberOfItems + 1 : "numberOfItems_increased";
    }
    
    public void pre_drawRectangleRounded (int x, int y, int width, int height, int arcWidth, int arcHeight, boolean isFilled)
    {
        setOld();
    }
    
    public void post_drawRectangleRounded (int x, int y, int width, int height, int arcWidth, int arcHeight, boolean isFilled)
    {
        getThis();
        getOld();
        assert numberOfItems == old_numberOfItems + 1 : "numberOfItems_increased";
    }
    
    public void pre_drawArc (int x, int y, int width, int height, int startAngle, int arcAngle, boolean isFilled)
    {
        setOld();
    }
    
    public void post_drawArc (int x, int y, int width, int height, int startAngle, int arcAngle, boolean isFilled)
    {
        getThis();
        getOld();
        assert numberOfItems == old_numberOfItems + 1 : "numberOfItems_increased";
    }
    
    public void pre_getNumberOfItems ()
    {
        
    }
    
    public void post_getNumberOfItems ()
    {
        int result = (Integer) getReturnValue();
        assert result >= 0 : "result_>=_0";
    }
    
    
    public void pre_getMaxX ()
    {
        
    }
    
    public void post_getMaxX ()
    {
        int result = (Integer) getReturnValue();
        assert result > 0 : "result_>_0";
    }
    
    public void pre_getMaxY ()
    {
        
    }
    
    public void post_getMaxY ()
    {
        int result = (Integer) getReturnValue();
        assert result > 0 : "result_>_0";
    }
    
    public void pre_getMaxNumberOfItems ()
    {
        
    }
    
    public void post_getMaxNumberOfItems ()
    {
        int result = (Integer) getReturnValue();
        assert result > 0 : "result_>_0";
    }
    
    
    // internal area
    
    private int numberOfItems;
    private int old_numberOfItems;
    
    private void getThis ()
    {
        numberOfItems = m_target.getNumberOfItems();
    }
    
    private void setOld ()
    {
        setPreconditionValue("numberOfItems", m_target.getNumberOfItems());
    }
    
    private void getOld ()
    {
        old_numberOfItems = (Integer) getPreconditionValue("numberOfItems");
    }
}
