package Prog1Tools;

import java.awt.*;

/** 
 * Implementierung des Grafikelements Text.
 * 
 * @author  hagen.buchwald@kit.edu
 * @version 1.0
 * @date 2010-08-30
 */
public class GraphicString implements GraphicItemSpec
{
    private int x;
    private int y;
    private String text;
    private Color color;
    
    /**
     * Konstruktor des Grafikelements Text.
     * 
     * @param x x-Koordinate des Startpunktes des Texts
     * @param y y-Koordinate des Startpunktes des Texts
     * @param text Text, der dargestellt werden soll
     * @param color Farbe, in der der Text erscheinen soll
     */
    public GraphicString (int x, int y, String text, Color color)
    {
        this.x = x;
        this.y = y;
        this.text = text;
        this.color = color;
    }
    
    public void paint (Graphics graphics)
    {
        Color oldColor = graphics.getColor();
        graphics.setColor(color);
        graphics.drawString(text, x, y);
        graphics.setColor(oldColor);
    }
}
    
