package Prog1Tools;

/** 
 * Spezifikation einer Klasse zum Erzeugen von Permutationen.
 * Quelle: Kenneth H. Rosen, Discrete Mathematics and Its Applications,
 * 2nd edition (NY: McGraw-Hill, 1991), pp. 282-284.
 * 
 * @author  hagen.buchwald@kit.edu
 * @version 1.0
 * @date 2010-08-30
 */
import net.sourceforge.c4j.*;

@ContractReference (contractClassName = "PermutationSpecContract")
public interface PermutationSpec
{
    
    /**
     * Kommando, die Permutationen wieder von vorn zu beginnen.
     */
    public void reset ();
    
    /**
     * Abfrage der noch ausstehenden Permutationen.
     */
    public long getNumLeft ();
    
    /**
     * Abfrage der Gesamtanzahl der Permutationen.
     */
    public long getTotal ();
    
    /**
     * Abfrage, ob noch weitere Permutationen ausstehen.
     */
    public boolean hasMore ();
    
    /**
     * Abfrage der Fakutltaet von n
     *
     * @param n Wert, fuer den die Fakutltaet berechnet werden soll.
     */
    public long getFactorial (int n);
    
    /**
     * Kommando, die naechste Permutation zu erzeugen.
     * Quelle: Kenneth H. Rosen, Discrete Mathematics and Its Applications, 2nd edition (NY: McGraw-Hill, 1991), pp. 282-284.
     */
    public int[] getNext ();
    
}

