package Prog1Tools;

import net.sourceforge.c4j.*;

public class PermutationSpecContract extends ContractBase<PermutationSpec>
{
    public PermutationSpecContract (PermutationSpec target)
    {
        super (target);
    }
    
    public void pre_reset ()
    {
        setPreconditionValue("old_numLeft", m_target.getNumLeft());
    }
    
    public void post_reset ()
    {
        long old_numLeft = (Long) getPreconditionValue("old_numLeft");
        assert old_numLeft <= m_target.getNumLeft() : "old_numLeft_<=_numLeft";
        previous_result = null;
    }
    
    public void pre_getNumLeft ()
    {
        
    }
    
    public void post_getNumLeft ()
    {
        long result = (Long) getReturnValue();
        assert result >= 0 : "result_>=_0";
    }
    
    public void pre_getTotal ()
    {
        
    }
    
    public void post_getTotal ()
    {
        long result = (Long) getReturnValue();
        assert result >= 1 : "result_>=_1";
    }
    
    public void pre_hasMore ()
    {
        
    }
    
    public void post_hasMore ()
    {
        boolean result = (Boolean) getReturnValue();
        if (result)
        {
            assert m_target.getNumLeft() > 0 : "if_hasMore_then_numLeft_>_0";
        }
    }
    
    public void pre_getFactorial (int n)
    {
        
    }
    
    public void post_getFactorial (int n)
    {
        long result = (Long) getReturnValue();
        assert result >= 1 : "result_>=_1";
    }
    
    public void pre_getNext ()
    {
        
    }
    
    int[] previous_result = null;
    
    public void post_getNext ()
    {
        int[] result = (int[]) getReturnValue();
        boolean equals = true;
        assert result != null : "result_not_null";
        if (previous_result != null)
        {
            if (result.length > 1)
            {
                for (int i = 0; i < result.length; i = i + 1)
                {
                    equals = equals && (previous_result[i] == result[i]);
                    previous_result[i] = result[i];
                }
                assert !equals : "previous_result_not_equals_result";
            }
        }
    }
    
}
