package Prog1Tools;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import net.sourceforge.c4j.*;
/** 
 * Vertragsklasse zum Interface ScreenSpec.
 * 
 * @author  hagen.buchwald@kit.edu
 * @version 2.0
 * @date 2011-03-02
 */
public class ScreenSpecContract extends ContractBase<ScreenSpec>
{
    public ScreenSpecContract (ScreenSpec target)
    {
        super (target);
    }
    
    public void pre_getSelectedMouseButton ()
    {
        
    }
    
    public void post_getSelectedMouseButton ()
    {
        int result = (Integer) getReturnValue();
        assert result == 0 ||
               result == MouseEvent.BUTTON1 ||
               result == MouseEvent.BUTTON2 ||
               result == MouseEvent.BUTTON3 : "result_is_0_or_Button1_or_Button2_or_Button3";
    }
    
    public void pre_getSelectedKeyCode ()
    {
        
    }
    
    public void post_getSelectedKeyCode ()
    {
        
    }
    
    public void pre_getSelectedKeyChar ()
    {
        
    }
    
    public void post_getSelectedKeyChar ()
    {
        
    }
    
    public void pre_getSelectedOption ()
    {
        
    }
    
    public void post_getSelectedOption ()
    {
        int result = (Integer) getReturnValue();
        assert result == ScreenSpec.OK_OPTION     ||
               result == ScreenSpec.YES_OPTION    ||
               result == ScreenSpec.NO_OPTION     ||
               result == ScreenSpec.CANCEL_OPTION ||
               result == ScreenSpec.CLOSED_OPTION ||
               result == ScreenSpec.APPROVE_FILE  ||
               result == ScreenSpec.CANCEL_FILE   : "result_is_APPROVE_or_CANCEL";
    }
    
    public void pre_getChoosenColor ()
    {
        
    }
    
    public void post_getChoosenColor ()
    {
        
    }
    
    public void pre_getChoosenFile ()
    {
        
    }
    
    public void post_getChoosenFile ()
    {
        
    }
    
    public void pre_setDebug (boolean debug)
    {
        
    }
    
    public void post_setDebug (boolean debug)
    {
        
    }
    
    public void pre_setResizable (boolean resizable)
    {
        
    }
    
    public void post_setResizable (boolean resizable)
    {
        
    }
    
    public void pre_resetFont ()
    {
        
    }
    
    public void post_resetFont ()
    {
        
    }
    
    public void pre_setFont (String fontName, int fontStyle, int fontSize)
    {
        assert fontName != null : "fontName_not_null";
        assert fontStyle >= 0 : "fontStyle_>=_0";
        assert fontSize > 0 : "fontSize_>_0";
    }
    
    public void post_setFont (String fontName, int fontStyle, int fontSize)
    {
        
    }
    
    public void pre_clearScreen ()
    {
        
    }
    
    public void post_clearScreen ()
    {
        
    }
    
    public void pre_clearScreen (boolean fastMode)
    {
        
    }
    
    public void post_clearScreen (boolean fastMode)
    {
        
    }
    
    public void pre_showMessageDialog (String title, String message)
    {
        assert title != null : "title_not_null";
        assert message != null : "message_not_null";
    }
    
    public void post_showMessageDialog (String title, String message)
    {
        assert m_target.getSelectedOption() == ScreenSpec.OK_OPTION : "selectedOption_set";
    }
    
    
    public void pre_showOptionDialogAbbruchOK (String title, String message)
    {
        assert title != null : "title_not_null";
        assert message != null : "message_not_null";
    }
    
    public void post_showOptionDialogAbbruchOK (String title, String message)
    {
        int result = (Integer) getReturnValue();
        assert result == ScreenSpec.OK_OPTION     ||
               result == ScreenSpec.CANCEL_OPTION ||
               result == ScreenSpec.CLOSED_OPTION : "result_is_OK_or_CANCEL_or_CLOSED";
        assert result == m_target.getSelectedOption() : "selectedOption_set";
    }
    
    
    public void pre_showOptionDialogJaNein (String title, String message)
    {
        assert title != null : "title_not_null";
        assert message != null : "message_not_null";
    }
    
    public void post_showOptionDialogJaNein (String title, String message)
    {
        int result = (Integer) getReturnValue();
        assert result == ScreenSpec.OK_OPTION     ||
               result == ScreenSpec.CANCEL_OPTION ||
               result == ScreenSpec.CLOSED_OPTION : "result_is_OK_or_CANCEL_or_CLOSED";
        assert result == m_target.getSelectedOption() : "selectedOption_set";
    }
    
    public void pre_showInputDialogComboBox (String title, String message, String[] comboBoxItems)
    {
        assert title != null : "title_not_null";
        assert message != null : "message_not_null";
        if (comboBoxItems != null)
        {
            assert comboBoxItems.length > 0 : "comboBoxItems_not_empty";
        }
        
        if (comboBoxItems != null)
        {
            for (String item : comboBoxItems)
            {
                assert item != null : "all_items_in_comboBoxItems_not_null";
            }
        } 
    }
    
    public void post_showInputDialogComboBox (String title, String message, String[] comboBoxItems)
    {
        String result = (String) getReturnValue();
        assert m_target.getSelectedOption() == ScreenSpec.OK_OPTION     ||
               m_target.getSelectedOption() == ScreenSpec.CANCEL_OPTION ||
               m_target.getSelectedOption() == ScreenSpec.CLOSED_OPTION : "result_is_OK_or_CANCEL_or_CLOSED";
        
        boolean itemSelected = false;
        if (comboBoxItems != null)
        {
            for (String item : comboBoxItems)
            {
                if (item.equals(result))
                {
                    itemSelected = true;
                }
            }

            if (m_target.getSelectedOption() == ScreenSpec.OK_OPTION)
            {
                assert itemSelected : "item_selected";
                assert result != null : "result_not_null";
            }
            if (m_target.getSelectedOption() == ScreenSpec.CANCEL_OPTION)
            {
                assert result == null : "result_is_null";
            }
        }     
    }
    
    public void pre_readByte (String title, String message)
    {
        assert title != null : "title_not_null";
        assert message != null : "message_not_null";
    }
    
    public void post_readByte (String title, String message)
    {
        byte result = (Byte) getReturnValue();
        assert m_target.getSelectedOption() == ScreenSpec.OK_OPTION     ||
               m_target.getSelectedOption() == ScreenSpec.CANCEL_OPTION ||
               m_target.getSelectedOption() == ScreenSpec.CLOSED_OPTION : "result_is_OK_or_CANCEL_or_CLOSED";
        if (m_target.getSelectedOption() == ScreenSpec.CANCEL_OPTION)
        {
            assert result == 0 : "if_CANCEL_then_result_is_0"; 
        }
    }
    
    public void pre_readShort (String title, String message)
    {
        assert title != null : "title_not_null";
        assert message != null : "message_not_null";
    }
    
    public void post_readShort (String title, String message)
    {
        short result = (Short) getReturnValue();
        assert m_target.getSelectedOption() == ScreenSpec.OK_OPTION     ||
               m_target.getSelectedOption() == ScreenSpec.CANCEL_OPTION ||
               m_target.getSelectedOption() == ScreenSpec.CLOSED_OPTION : "result_is_OK_or_CANCEL_or_CLOSED";
        if (m_target.getSelectedOption() == ScreenSpec.CANCEL_OPTION)
        {
            assert result == 0 : "if_CANCEL_then_result_is_0"; 
        }
    }
    
    public void pre_readInt (String title, String message)
    {
        assert title != null : "title_not_null";
        assert message != null : "message_not_null";
    }
    
    public void post_readInt (String title, String message)
    {
        int result = (Integer) getReturnValue();
        assert m_target.getSelectedOption() == ScreenSpec.OK_OPTION     ||
               m_target.getSelectedOption() == ScreenSpec.CANCEL_OPTION ||
               m_target.getSelectedOption() == ScreenSpec.CLOSED_OPTION : "result_is_OK_or_CANCEL_or_CLOSED";
        if (m_target.getSelectedOption() == ScreenSpec.CANCEL_OPTION)
        {
            assert result == 0 : "if_CANCEL_then_result_is_0";
        }
    }
    
    public void pre_readLong (String title, String message)
    {
        assert title != null : "title_not_null";
        assert message != null : "message_not_null";
    }
    
    public void post_readLong (String title, String message)
    {
        long result = (Long) getReturnValue();
        assert m_target.getSelectedOption() == ScreenSpec.OK_OPTION     ||
               m_target.getSelectedOption() == ScreenSpec.CANCEL_OPTION ||
               m_target.getSelectedOption() == ScreenSpec.CLOSED_OPTION : "result_is_OK_or_CANCEL_or_CLOSED";
        if (m_target.getSelectedOption() == ScreenSpec.CANCEL_OPTION)
        {
            assert result == 0L : "CANCEL_implies_result_is_0";
        }
                        
    }
    
    public void pre_readFloat (String title, String message)
    {
        assert title != null : "title_not_null";
        assert message != null : "message_not_null";
    }
    
    public void post_readFloat (String title, String message)
    {
        float result = (Float) getReturnValue();
        assert m_target.getSelectedOption() == ScreenSpec.OK_OPTION     ||
               m_target.getSelectedOption() == ScreenSpec.CANCEL_OPTION ||
               m_target.getSelectedOption() == ScreenSpec.CLOSED_OPTION : "result_is_OK_or_CANCEL_or_CLOSED";
        if (m_target.getSelectedOption() == ScreenSpec.CANCEL_OPTION)
        {
            assert result == 0.0 : "if_CANCEL_then_result_is_0.0";
        }
    }
    
    public void pre_readDouble (String title, String message)
    {
        assert title != null : "title_not_null";
        assert message != null : "message_not_null";
    }
    
    public void post_readDouble (String title, String message)
    {
        double result = (Double) getReturnValue();
        assert m_target.getSelectedOption() == ScreenSpec.OK_OPTION     ||
               m_target.getSelectedOption() == ScreenSpec.CANCEL_OPTION ||
               m_target.getSelectedOption() == ScreenSpec.CLOSED_OPTION : "result_is_OK_or_CANCEL_or_CLOSED";
        if (m_target.getSelectedOption() == ScreenSpec.CANCEL_OPTION)
        {
            assert result == 0.0 : "if_CANCEL_then_result_is_0.0"; 
        }
    }
    
    public void pre_readChar (String title, String message)
    {
        assert title != null : "title_not_null";
        assert message != null : "message_not_null";
    }
    
    public void post_readChar (String title, String message)
    {
        char result = (Character) getReturnValue();
        assert m_target.getSelectedOption() == ScreenSpec.OK_OPTION     ||
               m_target.getSelectedOption() == ScreenSpec.CANCEL_OPTION ||
               m_target.getSelectedOption() == ScreenSpec.CLOSED_OPTION : "result_is_OK_or_CANCEL_or_CLOSED";
        if (m_target.getSelectedOption() == ScreenSpec.CANCEL_OPTION)
        {
            assert result == (char)0 : "if_CANCEL_then_result_is_(char)0"; 
        }
    }
    
    public void pre_readBoolean (String title, String message)
    {
        assert title != null : "title_not_null";
        assert message != null : "message_not_null";
    }
    
    public void post_readBoolean (String title, String message)
    {
        boolean result = (Boolean) getReturnValue();
        assert m_target.getSelectedOption() == ScreenSpec.OK_OPTION     ||
               m_target.getSelectedOption() == ScreenSpec.CANCEL_OPTION ||
               m_target.getSelectedOption() == ScreenSpec.CLOSED_OPTION : "result_is_OK_or_CANCEL_or_CLOSED";
        if (m_target.getSelectedOption() == ScreenSpec.CANCEL_OPTION)
        {
            assert result == false : "if_CANCEL_then_result_is_false"; 
        }
    }
    
    public void pre_readLine (String title, String message)
    {
        assert title != null : "title_not_null";
        assert message != null : "message_not_null";
    }
    
    public void post_readLine (String title, String message)
    {
        String result = (String) getReturnValue();
        assert m_target.getSelectedOption() == ScreenSpec.OK_OPTION     ||
               m_target.getSelectedOption() == ScreenSpec.CANCEL_OPTION ||
               m_target.getSelectedOption() == ScreenSpec.CLOSED_OPTION : "result_is_OK_or_CANCEL_or_CLOSED";
        if (m_target.getSelectedOption() == ScreenSpec.CANCEL_OPTION)
        {
            assert result == null : "if_CANCEL_then_result_is_null"; 
        }
    }
    
    public void pre_showConfirmDialog (String title, String message)
    {
        assert title != null : "title_not_null";
        assert message != null : "message_not_null";
    }
    
    public void post_showConfirmDialog (String title, String message)
    {
        int result = (Integer) getReturnValue();
        assert result == ScreenSpec.YES_OPTION ||
               result == ScreenSpec.NO_OPTION  ||
               result == ScreenSpec.CANCEL_OPTION : "result_is_YES_or_NO_or_CANCEL";
        assert result == m_target.getSelectedOption() : "selectedOption_set";
    }
    
    public void pre_showFileOpenDialog ()
    {
        
    }
    
    public void post_showFileOpenDialog ()
    {
        int result = (Integer) getReturnValue();
        assert result == ScreenSpec.APPROVE_FILE ||
               result == ScreenSpec.CANCEL_FILE : "result_is_APPROVE_or_CANCEL";
        assert result == m_target.getSelectedOption() ||
               result == m_target.getSelectedOption() : "selectedOption_is_set";
        if (m_target.getSelectedOption() == ScreenSpec.CANCEL_FILE)
        {
            assert m_target.getChoosenFile() == null : "if_CANCEL_then_choosenFile_is_null";
        }
                        
        if (m_target.getSelectedOption() == ScreenSpec.APPROVE_FILE)
        {
            assert m_target.getChoosenFile() != null : "if_APPROVE_then_choosenFile_is_not_null";
        }
                        
    }
    
    public void pre_showFileSaveDialog ()
    {
        
    }
    
    public void post_showFileSaveDialog ()
    {
        int result = (Integer) getReturnValue();
        assert result == ScreenSpec.APPROVE_FILE ||
               result == ScreenSpec.CANCEL_FILE : "result_is_APPROVE_or_CANCEL";
        assert m_target.getSelectedOption() == result : "selectedOption_is_set";
        if (m_target.getSelectedOption() == ScreenSpec.CANCEL_FILE)
        {
            assert m_target.getChoosenFile() == null : "if_CANCEL_then_choosenFile_is_null";
        }
                        
        if (m_target.getSelectedOption() == ScreenSpec.APPROVE_FILE)
        {
            assert m_target.getChoosenFile() != null : "if_APPROVE_then_choosenFile_is_not_null";
        }
                        
    }
    
    public void pre_showColorChooserDialog (String title)
    {
        
    }
    
    public void post_showColorChooserDialog (String title)
    {
        int result = (Integer) getReturnValue();
        assert result == ScreenSpec.OK_OPTION ||
               result == ScreenSpec.CANCEL_OPTION : "result_is_OK_or_CANCEL";
        assert m_target.getSelectedOption() == result : "selectedOption_is_set";
        if (m_target.getSelectedOption() == ScreenSpec.CANCEL_OPTION)
        {
            assert m_target.getChoosenColor() == null : "if_CANCEL_then_choosenColor_is_null";
        }
                        
        if (m_target.getSelectedOption() == ScreenSpec.OK_OPTION)
        {
            assert m_target.getChoosenColor() != null : "if_APPROVE_then_choosenColor_is_not_null";
        }               
    }
    
    public void pre_resetMouseEvent ()
    {
        
    }
    
    public void post_resetMouseEvent ()
    {
        assert m_target.getSelectedMouseButton() == ScreenSpec.MOUSEBUTTON_RESET_VALUE :
               "selectedMouseButton_reset_to_MOUSEBUTTON_RESET_VALUE";
    }
    
    public void pre_resetKeyEvent ()
    {
        
    }
    
    public void post_resetKeyEvent ()
    {
        assert m_target.getSelectedKeyCode() == ScreenSpec.KEYCODE_RESET_VALUE :
               "selectedKeyCode_reset_to_KEYCODE_RESET_VALUE";
        assert m_target.getSelectedKeyChar() == ScreenSpec.KEYCHAR_RESET_VALUE :
               "selectedKeyChar_reset_to_KEYCHAR_RESET_VALUE";
    }
    
}
