package Prog1Tools;

import net.sourceforge.c4j.*;
/** 
 * Vertragsklasse zum Interface TurtleSpec.
 * 
 * @author  hagen.buchwald@kit.edu
 * @version 1.0
 * @date 2010-11-14
 */
public class TurtleSpecContract extends ContractBase<TurtleSpec>
{
    public TurtleSpecContract (TurtleSpec target)
    {
        super (target);
    }
    
    public void pre_setTurtle (int xPos, int yPos)
    {
        assert xPos >= 0 : "xPos_>=_0";
        assert yPos >= 0 : "yPos_>=_0";
    }
    
    public void post_setTurtle (int xPos, int yPos)
    {
        assert m_target.getPositionX() == xPos : "x_set";
        assert m_target.getPositionY() == yPos : "y_set";
    }
    
    public void pre_setHeading (int heading)
    {
        
    }
    
    public void post_setHeading (int heading)
    {
        if (heading < 0)
        {
            assert m_target.getHeading() == 360 - (Math.abs(heading) % 360) ||
                   m_target.getHeading() == 0 : "negative_heading_set";
        }
        else
        {
            assert m_target.getHeading() == heading % 360 ||
                   m_target.getHeading() == 0 : "positive_heading_set";
        }
        assert m_target.getHeading() >= 0  : "heading_>=_0";
        assert m_target.getHeading() < 360 : "heading_<_360";
        
    }
    
    int old_x = 0;
    int old_y = 0;
    
    public void pre_forward (int distance)
    {
        assert distance >= 1 : "distance_>=_1";
        old_x = m_target.getPositionX();
        old_y = m_target.getPositionY();
    }
    
    public void post_forward (int distance)
    {
        assert m_target.getPositionX() ==
               old_x + Math.round(distance * Math.cos(m_target.getHeading() / 180.0 * Math.PI)) : "x_moved";
        assert m_target.getPositionY() ==
               old_y + Math.round(distance * Math.sin(m_target.getHeading() / 180.0 * Math.PI)) : "y_moved";
    }
    
    public void pre_getPositionX ()
    {
        
    }
    
    public void post_getPositionX ()
    {
        
    }
    
    public void pre_getPositionY ()
    {
        
    }
    
    public void post_getPositionY ()
    {
        
    }
    
    public void pre_getHeading ()
    {
        
    }
    
    public void post_getHeading ()
    {
        
    }

    public void pre_showTurtle ()
    {
        
    }
    
    public void post_showTurtle ()
    {
        assert m_target.isVisibleTurtle() : "isVisible";
    }

    public void pre_hideTurtle ()
    {
        
    }
    
    public void post_hideTurtle ()
    {
        assert !m_target.isVisibleTurtle() : "not_isVisible";
    }

    public void pre_isVisibleTurtle ()
    {
        
    }
    
    public void post_isVisibleTurtle ()
    {
        
    }

    
}
